//
// UCSD p-System filesystem in user space
// Copyright (C) 2006 Peter Miller
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at
// you option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston MA 02111-1307,
// USA
//

#include <assert.h>

#include <lib/sector_io.h>


sector_io::~sector_io()
{
    assert(reference_count_valid());
}


sector_io::sector_io() :
    reference_count(1)
{
}


void
sector_io::reference_count_up()
{
    assert(reference_count_valid());
    ++reference_count;
}


void
sector_io::reference_count_down()
{
    assert(reference_count_valid());
    if (reference_count <= 1)
	delete this;
    else
	--reference_count;
}


int
sector_io::size_in_bytes()
{
    int rc = size_in_sectors();
    if (rc < 0)
	return rc;
    return (bytes_per_sector() * rc);
}


void
sector_io::bytes_per_sector_hint(unsigned)
{
    // Do nothing.
}
