#!/bin/sh
#
# UCSD p-System filesystem in user space
# Copyright (C) 2006 Peter Miller
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# you option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston MA 02111-1307,
# USA
#

TEST_SUBJECT="ucsdpsys_mkfs"

for dir in . bl blbl blblbl blblblbl
do
    incl=$dir/aegis.supplementary/test_prelude.inc.sh
    if [ -f $incl ]
    then
       	. $incl
	break
    fi
done

#
# Build a new file system.
#
$bindir/ucsdpsys_mkfs testing.dsk
test $? -eq 0 || fail

#
# Make sure the new file system.
#
$bindir/ucsdpsys_fsck testing.dsk
test $? -eq 0 || fail

#
# The functionality exercised by this test worked.
# No other assertions are made.
#
pass
