#!/bin/sh
#
# UCSD p-System filesystem in user space
# Copyright (C) 2006 Peter Miller
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# you option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston MA 02111-1307,
# USA
#

TEST_SUBJECT="ucsdpsys_charset"

for dir in . bl blbl blblbl blblblbl
do
    incl=$dir/aegis.supplementary/test_prelude.inc.sh
    if [ -f $incl ]
    then
       	. $incl
	break
    fi
done

#
# insert your test here...
#
cat > test.in << 'fubar'
'P' = {
    "XXXXX ",
    " X   X",
    " X   X",
    " XXXX ",
    " X    ",
    " X    ",
    "XXX   ",
    "      ",
};
'M' = {
    "X    X ",
    "XX  XX  ",
    "X XX X ",
    "X XX X  ",
    "X    X ",
    "X    X",
    "X    X "
};
fubar
test $? -eq 0 || no_result

cat > test.ok << 'fubar'
#
# This file defines the shapes of the characters for
# drawing them on the screen.  This what is known as a
# bit-mapped font.
#
# Note that font outlines and bit-mapped fonts are not
# eligible for copyright protection.  Only fonts which
# contain computer code (e.g. some PostScript fonts)
# are eligible for copyright protection.
#
'M' = {
    "X    X  ",
    "XX  XX  ",
    "X XX X  ",
    "X XX X  ",
    "X    X  ",
    "X    X  ",
    "X    X  ",
    "        ",
};
'P' = {
    "XXXXX   ",
    " X   X  ",
    " X   X  ",
    " XXXX   ",
    " X      ",
    " X      ",
    "XXX     ",
    "        ",
};
fubar
test $? -eq 0 || no_result

$bindir/ucsdpsys_charset -e test.in test.bin
test $? -eq 0 || fail

$bindir/ucsdpsys_charset -d test.bin test.out
test $? -eq 0 || fail

diff test.ok test.out
test $? -eq 0 || fail

#
# The functionality exercised by this test worked.
# No other assertions are made.
#
pass
