//
// UCSD p-System filesystem in user space
// Copyright (C) 2006 Peter Miller
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at
// you option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston MA 02111-1307,
// USA
//

#ifndef UCSDPSYS_CHARSET_DUMP_H
#define UCSDPSYS_CHARSET_DUMP_H

/**
  * The dump function is used to read a binary font definition file
  * (SYSTEM.CHARSET") and write out a pretty printed text format
  * suitable for editing.
  *
  * @param infile
  *     The name of the binary file to read, or "-" for stdin.
  * @param outfile
  *     The name of the text file to write, or "-" for stdout.
  */
void dump(const char *infile, const char *outfile);

#endif // UCSDPSYS_CHARSET_DUMP_H
