//
// UCSD p-System filesystem in user space
// Copyright (C) 2006 Peter Miller
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at
// you option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston MA 02111-1307,
// USA
//

#ifndef UCSDPSYS_TEXT_FILTER_ENCODE_H
#define UCSDPSYS_TEXT_FILTER_ENCODE_H

#include <ucsdpsys_text/filter.h>

/**
  * The filter_encode class is used to represent a filter which
  * translated Unix text files into UCSD p-System text files.
  */
class filter_encode:
    public filter
{
public:
    /**
      * The destructor.
      */
    virtual ~filter_encode();

    /**
      * The default constructor.
      */
    filter_encode();

    // See base class for documentation.
    void translate(FILE *ifp, const rcstring &ifn, FILE *ofp,
	const rcstring &ofn);

private:
    /**
      * The copy constructor.
      */
    filter_encode(const filter_encode &);

    /**
      * The assignment operator.
      */
    filter_encode &operator=(const filter_encode &);
};

#endif // UCSDPSYS_TEXT_FILTER_ENCODE_H
