/*
 * UCSD p-System virtual machine
 * Copyright (C) 2000 Mario Klebsch
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>
 */

#include <stdio.h>

#include <lib/psystem.h>
#include <lib/memory.h>
#include <ucsdpsys_vm/array.h>

#undef DEBUG

word csp_TreeSearch(word TokenBuf, word ResultPtr, word NodePtr)
{
  word  Link;

#ifdef DEBUG
  int i;

  for (i=0; i<8;i++)
    putchar(MemRdByte(TokenBuf, i));
  printf(": ");
#endif

  while (1)
    {
      int cmp=ByteCmp(TokenBuf, NodePtr, 8);
      if (cmp<0)
        if ((Link=MemRd(WordIndexed(NodePtr,5))))
          NodePtr=Link;                 /* follow RightLink                 */
        else
          {
#ifdef DEBUG
            printf("not found, should be on right node\n");
#endif
            MemWr(ResultPtr, NodePtr);
            return(0xffff);
          }
      else if (cmp>0)
        if ((Link=MemRd(WordIndexed(NodePtr,4))))
          NodePtr=Link;                 /* follow LeftLink                  */
        else
          {
#ifdef DEBUG
            printf("not found, should be on left node\n");
#endif
            MemWr(ResultPtr, NodePtr);
            return(1);
          }
      else
        {
#ifdef DEBUG
          printf("found\n");
#endif
          MemWr(ResultPtr, NodePtr);
          return(0);
        }
    }
}
