/*
    This file is part of an implementation of the UCSD I.5 psuedo-machine.
    Copyright (C) 1994,1995,2006 Richard. W. Stearn

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Email: richard@rns-stearn.demon.co.uk
*/

#include <fcntl.h>
#include <string.h>
#include <ctype.h>
#include "pme.h"
#include "ucsd_consts.h"
#include "unit_io.h"

extern int dflag;

extern struct unit_entry unit_table[ MAX_UNITS ];

void read_config( char *config_file )
{
unit_table[  1 ].type = UNIT_CONSOLE;
unit_table[  1 ].fd = 1;

unit_table[  2 ].type = UNIT_CONSOLE;
unit_table[  2 ].fd = 0;

unit_table[  3 ].type = UNIT_GRAPHIC;
unit_table[  3 ].device = "/dev/null";
unit_table[  3 ].flags = O_RDWR;

unit_table[  4 ].type = UNIT_DISK;
unit_table[  4 ].device = "../ucsd_vols/sys3.5";
unit_table[  4 ].flags = O_RDWR;

unit_table[  5 ].type = UNIT_DISK;
unit_table[  5 ].device = "../ucsd_vols/pascal1";
unit_table[  5 ].flags = O_RDWR;

unit_table[  6 ].type = UNIT_SERIAL;
unit_table[  6 ].device = "/dev/null";
unit_table[  6 ].flags = O_RDWR;

unit_table[  7 ].type = UNIT_SERIAL;
unit_table[  7 ].device = "/dev/null";
unit_table[  7 ].flags = O_RDWR;

unit_table[  8 ].type = UNIT_PARALLEL;
unit_table[  8 ].device = "/dev/null";
unit_table[  8 ].flags = O_RDWR;

unit_table[  9 ].type = UNIT_DISK;
unit_table[  9 ].device = "../ucsd_vols/i.5";
unit_table[  9 ].flags = O_RDWR;

unit_table[ 10 ].type = UNIT_DISK;
unit_table[ 10 ].device = "../ucsd_vols/edit.img";
unit_table[ 10 ].flags = O_RDWR;

unit_table[ 11 ].type = UNIT_DISK;
unit_table[ 11 ].device = "../ucsd_vols/ams1";
unit_table[ 11 ].flags = O_RDWR;

unit_table[ 12 ].type = UNIT_DISK;
unit_table[ 12 ].device = "../ucsd_vols/ams2";
unit_table[ 12 ].flags = O_RDWR;

unit_table[ 13 ].type = UNIT_PARALLEL;
unit_table[ 13 ].device = "/dev/null";
unit_table[ 13 ].flags = O_RDWR;

unit_table[ 14 ].type = UNIT_PARALLEL;
unit_table[ 14 ].device = "/dev/null";
unit_table[ 14 ].flags = O_RDWR;

unit_table[ 15 ].type = UNIT_PARALLEL;
unit_table[ 15 ].device = "/dev/null";
unit_table[ 15 ].flags = O_RDWR;
}
