#ifndef _UCSD_DISK_H_
#define _UCSD_DISK_H_

/*
    This file is part of an implementation of the UCSD I.5 psuedo-machine.
    Copyright (C) 1994,1995,2006 Richard. W. Stearn

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Email: richard@rns-stearn.demon.co.uk
*/

#define UCSD_DIRBLK	2 /* first block of dir in volume */

#define UCSD_MAXDIR	78 /* max number of entries in a dir */
#define UCSD_DIR_SIZE	2048 /* dir size in bytes + filler to make 2^n */

#define UCSD_VIDLENG	7 /* maximum vol name length */
#define UCSD_TIDLENG	15 /* maximum file name length */

/* enums for dfkind */
#define UNTYPEDFILE	0
#define XDSKFILE	1
#define CODEFILE	2
#define TEXTFILE	3
#define INFOFILE	4
#define DATAFILE	5
#define GRAFFILE	6
#define FOTOFILE	7
#define SECUREDIR	8
#define SUBSVOL		9

struct daterec
	{
	word	month:4,/* 0 .. 15, 0  implies date not meaningful*/
		day:5,  /* 0 .. 31, day of month*/
		year:7; /* 0 .. 100, 100 is temp disk flag*/
	} ;

struct ucsd_dir_entry {
	word dfirstblk;
	word dlastblk;
	word dfkind;
	union {
		struct ucsd_dir_ent1
			{
			char dvid[ UCSD_VIDLENG + 1 ];
			word deovblk;
			word dnumfiles;
			word dloadtime;
			struct daterec dlastboot; /* date record */
			} v_ent;
		struct ucsd_dir_ent2
			{
			char dtid[ UCSD_TIDLENG + 1 ];
			word dlastbyte;
			struct daterec daccess; /* date record */
			} t_ent;
		} d;
	};

#endif
