#ifndef _UNIT_IO_H_
#define _UNIT_IO_H_

/*
    This file is part of an implementation of the UCSD I.5 psuedo-machine.
    Copyright (C) 1994,1995,2006 Richard. W. Stearn

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Email: richard@rns-stearn.demon.co.uk
*/

#define UNIT_NULL	0
#define UNIT_CONSOLE	1
#define UNIT_GRAPHIC	2
#define UNIT_DISK	3
#define UNIT_SERIAL	4
#define UNIT_PARALLEL	5

#define EIONOERROR	0
#define EIOPARITY	1
#define EIOILLUNIT	2
#define EIOILLIORQ	3
#define EIOTIMEOUT	4
#define EIOOFFLINE	5
#define EIOFILELOST	6
#define EIOBADFILE	7
#define EIONOROOM	8
#define EIONOVOL	9
#define EIONOFILE	10
#define EIODUPDIR	11
#define EIOFILEOPEN	12
#define EIOFILENOTOPEN	13
#define EIOBADINPUT	14
#define EIOBUFFOVR	15
#define EIOWRITEPROT	16
#define EIOILLBLOCK	17
#define EIOBADCOUNT	18
#define EIOBADINIT	19
#define EIODELDATA	20
#define EIONOREC	21
#define EIOLOSTDATA	22
#define EIODISKERR	23

struct unit_entry
	{
	int type;
	char *device;
	int fd;
	int flags;
	} ;

struct unit_io_operations
	{
	word (*unit_read) ( word unit_num, word buffer_addr, word length, word block );
	word (*unit_write) ( word unit_num, word buffer_addr, word length, word block );
	word (*unit_clear) ( word unit_num );
	word (*unit_busy) ( word unit_num );
	word (*unit_wait) ( word unit_num );
	word (*unit_stat) ( word unit_num, word buffer_addr, word length, word dummy );
	word (*unit_init) ( word unit_num );
	word (*unit_halt) ( word unit_num );
	} ;

void init_unit_io( char *config_filename );
void halt_unit_io();

word unit_read( word unit_num, word buffer_addr, word length, word block, word flags );
word unit_write( word unit_num, word buffer_addr, word length, word block, word flags );
word unit_clear( word unit_num );
word unit_busy( word unit_num );
word unit_wait( word unit_num );
word unit_stat( word unit_num, word buffer_addr, word length, word flags );
word unit_init( word unit_num );
word unit_halt( word unit_num );

#endif
